﻿function sendMessage() {
    if ($.trim($("#userName").val()) == "") {
        alert("S'il vous plait, choisir un nom!");
    }
    else if (pageKey() == "" || pageKey() == "=") {
        alert("La clé est manquante (la partie de l'URL du site après '#').");
    }
    else {
        if ($.trim($("#textMessage").val()) != "") {

            var key = pageKey();

            $.post("sendMessage.php", { roomId: roomId, user: zeroCipher(key, $.trim($("#userName").val())), message: zeroCipher(key, $.trim($("#textMessage").val())) }, function (data) {
                if (data != false) {
                    $("#textMessage").val("");
                    $("#textMessage").focus();
                    getMessages(false);
                } else {
                    // error : the message was not recorded
                    alert("Une erreur est survenue... :(");
                }
            });
        }
    }
}

var isRefreshTitle = false;
var refreshTitleInterval;
var nbIps = 1;

function getMessages(changeTitle) {
    var key = pageKey();
    $.post("getMessages.php", { roomId: roomId, dateLastGetMessages: dateLastGetMessages, nbIps: nbIps }, function (data) {
        if (data == "noRoom") {
            // closed conversation
            $("#chatroom").html("<i>Cette conversation est terminée ... Vous devez en commencer une nouvelle pour continuer à parler!</i>");
            stopTimerCheck();
        } else if (data == "destroyed") {
            // closed conversation
            $("#chatroom").html("<i>Cette conversation s'est auto-détruite. Elle à été crée pour un seul visiteur.</i>");
            stopTimerCheck();
        } else if (data != "noNew") {
            if (data.chatLines == undefined) {
                $("#nbUsers").html(data.nbIps);
            } else if (data.chatLines == "") {
                if (key == "" || key == "=") {
                    document.location.hash = "#" + generateRandomKey();
                }
                $("#chatroom").html("<i>Pas de messages pour le moment...</i>");
            } else if (key == "" || key == "=") {
                $("#chatroom").html("<i>La clé est manquante (la partie de l'URL du site Web après «#»).</i>");

                stopTimerCheck();
            } else {
                var hasErrors = false;
                var hasElements = false;
                var chatRoom = $("#chatroom");
                chatRoom.html("");

                nbIps = data.nbIps;
                $("#nbUsers").html(data.nbIps);

                for (i = 0; i < data.chatLines.length; i++) {
                    try {
                        var user = zeroDecipher(key, data.chatLines[i].userId);
                        var decryptedMessage = zeroDecipher(key, data.chatLines[i].message);

                        hasElements = true;

                        if (vizhash.supportCanvas()) {
                            var vhash = vizhash.canvasHash(data.chatLines[i].hash, 15, 10);
                            chatRoom.append("<span class='chathour'>(" + getDateFromTimestamp(data.chatLines[i].date) + ")</span> ");
                            chatRoom.append(vhash.canvas);
                            chatRoom.append(" <b>" + htmlEncode(user) + "</b> : " + replaceUrlTextWithUrl(htmlEncode(decryptedMessage)) + "<br />");
                        } else {
                            chatRoom.append("<i>" + data.chatLines[i].date + "</i> - <b>" + htmlEncode(user) + "</b> : " + replaceUrlTextWithUrl(htmlEncode(decryptedMessage)) + "<br />");
                        }
                    } catch (e) {
                        hasErrors = true;
                    }
                }
                if (!hasElements && hasErrors) {
                    // wrong key error
                    $("#chatroom").html("La clé semble être corrompue. Etes-vous sûr d'avoir copié l'URL complète (avec #xxxxxxxxxxxxxxxx-xxxxxxx-xxxxxxxx) ?");

                    stopTimerCheck();
                } else {
                    var objDiv = document.getElementById("chatroom");
                    objDiv.scrollTop = objDiv.scrollHeight;
                    dateLastGetMessages = data.dateLastGetMessages;

                    if (changeTitle && !isRefreshTitle) {
                        refreshTitleInterval = setInterval(
                            function () {
                                if (document.title == "Private chat room - MyCryptoChat par HowTommy.net") {
                                    document.title = "Nouveau message ! - MyCryptoChat par HowTommy.net";
                                } else {
                                    document.title = "Private chat room - MyCryptoChat by HowTommy.net";
                                }
                            }, 3000);
                        isRefreshTitle = true;
                    }
                }
            }
        }
    });
}

function replaceUrlTextWithUrl(content) {
    var re = /((http|https|ftp):\/\/[\w?=&.\/-;#@~%+-]+(?![\w\s?&.\/;#~%"=-]*>))/ig;
    content = content.replace(re, '<a href="$1" rel="nofollow">$1</a>');
    re = /((magnet):[\w?=&.\/-;#@~%+-]+)/ig;
    content = content.replace(re, '<a href="$1">$1</a>');
    return content;
}

function stopRefreshTitle() {
    if (isRefreshTitle) {
        clearInterval(refreshTitleInterval);
        document.title = "Private chat room - MyCryptoChat par HowTommy.net";
        isRefreshTitle = false;
    }
}

function htmlEncode(value) {
    return $('<div/>').text(value).html();
}

function generateRandomKey() {
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

    for (var i = 0; i < 30; i++) {
        text += possible.charAt(Math.floor(Math.random() * possible.length));
    }

    return text;
}

var checkIntervalTimer;

function stopTimerCheck() {
    clearInterval(checkIntervalTimer);
}

function getDateFromTimestamp(date) {
    var date = new Date(date * 1000);
    var hours = date.getHours();
    var minutes = date.getMinutes();
    hours = hours > 9 ? hours : "0" + hours;
    minutes = minutes > 9 ? minutes : "0" + minutes;

    return hours + ':' + minutes;
}

$(function () {
    getMessages(false);

    // try to get new messages every 15 seconds
    checkIntervalTimer = setInterval("getMessages(true)", 15000);

    $('body').on('mousemove', stopRefreshTitle);
});